	ld hl,scrbuf&#ff00
	ld de,+(scrbuf&#ff00)+1
	ld bc,#2000-1
	ld (hl),0
	ldir ;clear scrbuf
	
	call GENLOG2
	call GEN2X
	if SMALLLINES
	call mklines
	endif
	;ld hl,#4000
	;ld de,#4001
	;ld bc,#0800;#1800
	;ld (hl),l
        jp maingo

;GEN TABLE Y.B=2^(X/256)-1 ,X=(0;1)
GEN2X
        LD IX,TB2X
        LD HL,0
GN2X    LD A,H;ROUNDING
        BIT 7,L
        JR Z,$+3
        INC A
        LD (IX),A
        XOR A
        EXX 
        LD L,A
	ld H,A
	ld E,A
        LD BC,#00B2;(2^1/256)*#10000
        EXX 
        LD BC,#1801
GN2X1   RR C
	rr H
	rr L
        EXX 
        JR NC,GN2X2
        ADD HL,BC
        ADC A,1
GN2X2   RRA 
        RR H
	rr L
        EXX 
        DJNZ GN2X1
        LD A,C
        RRA 
        EXX 
        LD H,L
	ld L,A
        INC LX
        JR NZ,GN2X
        RET 

;GEN TABLE Y.W=LOG2(X) ,X=(1,255)
GENLOG2
        LD HL,TBLOG2
        XOR A
        LD E,A
	ld D,A
        LD (HL),A
        INC H
        LD (HL),#F0
        DEC H
        INC L
GNLG1   LD (HL),D
        INC H
        LD (HL),A
        DEC H
        EXA 
        PUSH HL,DE
        LD DE,#7440
        LD C,L
        SRL C
        RR D
        XOR A
        LD HL,#B8AA
        EXX 
        LD H,A
	ld L,A
        LD B,#10
GNLG2   EXX 
        ADD HL,HL
        ADC A,A
        SBC HL,DE
        SBC A,C
        JR NC,GNLG3
        ADD HL,DE
        ADC A,C
GNLG3   EXX 
        CCF 
        adc hl,hl
        ;rl l
        ;rl h
        DJNZ GNLG2
        POP DE
        EXA 
        ADD HL,DE
        ADC A,B
        EX DE,HL
        POP HL
        INC L
        JR NZ,GNLG1
        RET 

	if SMALLLINES
mklines
	ld hl,prog
	ld ix,progtable
;generate progs for all angles
	ld b,64;32 ;angles
mklines_angles0
	push bc
	ld a,64;32
	sub b ;0..63;31 (todo optimize)
	;find dx,dy for given angle
	push hl
	;add a,a ;angle*2 (there are 64 angles in the table)
	add a,a
	ld hl,tsines
	add a,l
	ld l,a
	adc a,h
	sub l
	ld h,a
	ld e,(hl) ;dx
	inc hl
	ld d,(hl) ;dy
	xor a
	sub e
	ld e,a
	xor a
	sub d
	ld d,a
	ld (mklinedraw_dxdy),de
	pop hl
	call mkline
	ld (ix+0),e
	ld (ix+1),d ;entry (todo optimize)
	inc ix
	inc ix
	;ld de,(mklinedraw_dxdy)
	;sra d
	;sra e
	;ld (mklinedraw_dxdy),de
	;call mkline
	;ld (ix+0),e
	;ld (ix+1),d ;entry (todo optimize)
	;inc ix
	;inc ix
	pop bc
	djnz mklines_angles0

;generate jumptable
	ld d,-32 ;dy
	ld b,64
mklines_dy0
	push bc
	ld e,-linemaxhgt;-31 ;dx
	ld b,linemaxhgt*2+1;63
mklines_dx0
	push bc
	push de
	push hl
	ld a,e ;dx
	add a,jumptable_center/256 ;#a0xx..#dfxx -  
	ld hx,a
	ld a,d ;dy
	add a,a
	add a,a
	ld lx,a
	;find angle from dx,dy (signed)
	call atan2
	;de=%000yyyyy 000xxxxx (abs)
	;a=angle=0..255
	;find prog for given angle
	bit 4,d
	jr nz,mklines_long
	bit 4,e
	jr nz,mklines_long
mklines_short
	add a,4 ;   2 ("0"=-4..+3, "2"=+4..+11...)
	rra
	rra
	and #3e ;  
	ld l,a
	ld a,d
	cp 3
	jr nc,mklines_longq
	ld a,e
	cp 3
	jr nc,mklines_longq
	ld a,#c9
	jp mklines_wrjp ;too short
mklines_long
	add a,2 ;   1 ("0"=-2..+1, "1"=+2..+5, "2"=+6..+9...)
	rra
	rra
	and #3f ; /     
	ld l,a
mklines_longq
	ld h,0
	add hl,hl
	ld de,progtable
	add hl,de
	ld e,(hl)
	inc hl
	ld d,(hl)
	;ld a,#c3
mklines_wrjp
	pop hl
	ld (ix+0),#c3
	ld (ix+1),line_slow_dy&#ff
	ld (ix+2),line_slow_dy/256
	 ld a,l
	 cp -4*8
	 jp m,mklines_wrjpq
	 cp +4*8
	 jp p,mklines_wrjpq
	ld (ix+1),e
	ld (ix+2),d ;entry
mklines_wrjpq
	pop de
	inc e ;dx++
	pop bc
	djnz mklines_dx0
	inc d ;dy++
	pop bc
	djnz mklines_dy0
	;ld a,#c9 ;ret
	;ld (#c000),a ;dx=dy=0
	ret

mkline
	ld c,l ;00 entry
	ld a,%00000000
	call mklinedraw ;00
	ld b,l ;0x entry
	ld (hl),#cb
	inc hl
	ld (hl),#2c ;sra h
	inc hl
	ld (hl),#30 ;jr nc
	inc hl
	ld a,c
	sub l
	dec a
	ld (hl),a ;disp to 00
	inc hl
	ld a,%01000000
	call mklinedraw ;01
	ld c,l ;10 entry
	ld a,%10000000
	call mklinedraw ;10
	push hl ;entry
	ld (hl),#eb ;ex de,hl
	inc hl
	;ld (hl),#cb
	;inc hl
	;ld (hl),#2c ;sra h
	;inc hl
	ld (hl),#30 ;jr bc
	inc hl
	ld a,b
	sub l
	dec a
	ld (hl),a ;disp to 0x
	inc hl
	ld (hl),#cb
	inc hl
	ld (hl),#2c ;sra h
	inc hl
	ld (hl),#30 ;jr nc
	inc hl
	ld a,c
	sub l
	dec a
	ld (hl),a ;disp to 10
	inc hl
	ld a,%11000000
	call mklinedraw ;11
	pop de ;entry
	ret

	;set n,(hl)
	;;inc l
	;;inc h
mklinedraw
	push bc
mklinedraw_dxdy=$+1
	ld de,0
;e=dx=-31..+31
;d=dy=-31..+31
;a=%xx000000
	ld c,a
	push hl
	bit 7,e ;dx
	ld hl,mkline_incx
	jr z,mklinedraw_dxpos
	xor a
	sub e
	ld e,a ;dx=0..31
	ld hl,mkline_decx
mklinedraw_dxpos
	ld (mkline_incdecx_jp),hl
	pop hl
	bit 7,d ;dy
	ld a,#2c ;inc l
	jr z,mklinedraw_dypos
	xor a
	sub d
	ld d,a ;dy=0..31
	ld a,#2d ;dec l
mklinedraw_dypos
	ld (mkline_incdecy_opcode),a
	LD A,d ;dy
	CP e ;dx
	JR NC,HORNV ;dy>=dx, dx<=dy
HORNH ;
	LD A,e
	LD B,e ;dx
	INC B ;dx+1 pixels
	CPL 
	;SCF ; CY=1 
	RRA ;mym:=256-(dx div 2)
HORNH0
	call mkline_pixel
	call mkline_incdecx
	ADD A,d ;mym:=mym+dy
	JR NC,HORNHQ
	SUB e ;mym:=mym-dx
	call mkline_incdecy
HORNHQ	DJNZ HORNH0
	JP HORNQ
HORNV ;
	LD B,d ;dy
	INC B ;dy+1 pixels
	CPL
	SCF ;CY=1
	RRA ;xm:=256-(dy div 2)
HORNV0	call mkline_pixel
	ADD A,e ;xm:=xm+dx
	JR NC,HORNVQ
	SUB d ;xm:=xm-dy {dy<>0!!!}
	call mkline_incdecx
HORNVQ	call mkline_incdecy
	DJNZ HORNV0 
HORNQ
	call mkline_finishpixel
mkline_pixelend=$+1
	ld hl,0
	pop bc
	ld (hl),#c9
	inc hl
	ret

mkline_incdecy
	call mkline_finishpixel
mkline_incdecy_opcode=$+1
	ld (hl),#2c ;inc l
	;ld (hl),#2d ;dec l
	inc hl
	ret

mkline_finishpixel
	push af
mkline_npixels=$+1
	ld a,0
	cp 2
	jr c,mkline_finishpixelq
mkline_pixelbeg=$+1
	ld hl,0
	ld (hl),#36 ;ld (hl),n
	inc hl
	ld (hl),#ff
mkline_pixelsmask=$+1
	ld a,0
	cp (hl)
	jr z,mkline_finishpixelqff
	dec hl
	ld (hl),#7e ;ld a,(hl)
	inc hl	
	ld (hl),#f6 ;or n
	inc hl	
	ld (hl),a
	inc hl	
	ld (hl),#77 ;ld (hl),a
mkline_finishpixelqff
	inc hl	
	ld (mkline_pixelend),hl
mkline_finishpixelq
	xor a
	ld (mkline_npixels),a
	ld (mkline_pixelsmask),a
	pop af
	ret

mkline_incdecx
	push af
	ld a,c ;%xxx00000
mkline_incdecx_jp=$+1
	jp mkline_incx
mkline_incx
	add a,%00100000
	ld c,a
	jr nc,mkline_incxq
	call mkline_finishpixel
	ld (hl),#24 ;inc h
	inc hl
mkline_incxq
	pop af
	ret
mkline_decx
	sub %00100000
	ld c,a
	jr nc,mkline_decxq
	call mkline_finishpixel
	ld (hl),#25 ;dec h
	inc hl
mkline_decxq
	pop af
	ret

mkline_pixel
	push af
	ld a,(mkline_npixels)
	or a
	jr nz,$+2+3
	 ld (mkline_pixelbeg),hl
	ld a,c ;%xxx00000
	rrca
	rrca ;%00xxx000
	xor #fe ;todo optimize
	 ld (hl),#34 ;inc (hl) ; !!!
	 cp #c6
	 jr z,mkline_pixel_0
	ld (hl),#cb
	inc hl
	ld (hl),a ;#c6/#ce...#fe ;set n,(hl)
mkline_pixel_0
	inc hl
	ld (mkline_pixelend),hl
	 inc a
	 ld (mkline_pixel_setopcode),a ;set n,a
	 ld a,(mkline_pixelsmask)
mkline_pixel_setopcode=$+1
	 set 0,a
	 ld (mkline_pixelsmask),a
	ld a,(mkline_npixels)
	inc a
	ld (mkline_npixels),a
	pop af
	ret

atan2
;e=dx=-31..+31
;d=dy=-31..+31
            ;192
;128;-dx,-dy ;+dx,-dy
    ;-dx,+dy ;+dx,+dy ;0
            ;64
	xor a
	bit 7,d
	jr z,atan2_dypos
;atan2_dyneg
	sub d
	ld d,a
	xor a
	bit 7,e
	jr z,atan2_dyneg_dxpos
;atan2_dyneg_dxneg
	sub e
	ld e,a
	ld a,128
atan2_dypos_dxpos
	call atan2_index
	add a,(hl) ;0..64
	ret
atan2_dypos
	bit 7,e
	jr z,atan2_dypos_dxpos
;atan2_dypos_dxneg
	sub e
	ld e,a
	ld a,128
atan2_dyneg_dxpos
	call atan2_index
	sub (hl) ;0..64
	ret

atan2_index
	push de
	;%000yyyyy 000xxxxx
	sla e
	sla e
	sla e
	;%000yyyyy xxxxx000
	srl d
	rr e
	srl d
	rr e
	srl d
	rr e
	;%000000yy yyyxxxxx
	ld hl,tatan2
	add hl,de ;+%yy yyyxxxxx
	pop de
	ret

	;align 256
tatan2
	;incbin "atan2" ;#YX ;0..64 = 0..pi/2
	incbin "atan2_32" ;+%yy yyyxxxxx ;0..64 = 0..pi/2
tsines
	;incbin "sines" ;dx,dy (64 angles)
	incbin "sineeven" ;dx,dy (64 angles: short,long,short...)
	endif ;SMALLLINES
